(in-package "COMMON-LISP-USER")

#+cmu #-clx (require :cmucl-clx)

(defpackage "MORPHICL"
  (:use "COMMON-LISP")
  (:export
    "CANVAS"
    "CANVASP"
    "CANVAS-WIDTH"
    "CANVAS-HEIGHT"
    "CANVAS-TRANSFORM-POINT"
    "CANVAS-TRANSFORM-RECTANGLE"
    "CANVAS-TRANSLATE-POINT"
    "CANVAS-TRANSLATE-RECTANGLE"
    "CANVAS-DRAW-LINE"
    "CANVAS-DRAW-LINES"
    "CANVAS-DRAW-POINT"
    "CANVAS-DRAW-POINTS"
    "CANVAS-OUTLINE-POLYGON"
    "CANVAS-FILL-POLYGON"
    "CANVAS-OUTLINE-RECTANGLE"
    "CANVAS-FILL-RECTANGLE"
    "CANVAS-OUTLINE-ELLIPSE"
    "CANVAS-FILL-ELLIPSE"
    "CANVAS-DRAW-TEXT"
    "CANVAS-FOREGROUND-COLOR"
    "CANVAS-BACKGROUND-COLOR"
    "CANVAS-FONT"
    "CANVAS-TRANSFORMATION"
    "CANVAS-CLIPPING-RECTANGLE"
    "WITH-CANVAS-OPTIONS"

    "PORT"
    "PORTP"
    "PORT-WORLD"
    "PORT-INPUT-FOCUS"
    "PORT-READ-EVENT"
    "PORT-UNREAD-EVENT"
    "PORT-PEEK-EVENT"
    "PORT-HANDLE-EVENT"
    "PORT-LISTEN"
    "PORT-CLOSE"
    "*DEFAULT-PORT*"

    "EVENT"
    "KEYBOARD-EVENT"
    "KEY-EVENT"
    "KEY-PRESS-EVENT"
    "KEY-RELEASE-EVENT"
    "POINTER-EVENT"
    "POINTER-BUTTON-EVENT"
    "POINTER-BUTTON-PRESS-EVENT"
    "POINTER-BUTTON-RELEASE-EVENT"
    "POINTER-MOTION-EVENT"
    "EVENTP"
    "KEYBOARD-EVENT-P"
    "POINTER-EVENT-P"
    "DEVICE-EVENT-DEVICE"
    "KEY-EVENT-KEY"
    "POINTER-BUTTON-EVENT-BUTTON"
    "+POINTER-BUTTON-LEFT+"
    "+POINTER-BUTTON-MIDDLE+"
    "+POINTER-BUTTON-RIGHT+"

    "FONT"
    "FONTP"
    "MAKE-FONT"
    "FONT-NAME"
    "FONT-CANVAS"
    "FONT-WIDTH"
    "FONT-HEIGHT"

    "COLOR"
    "COLORP"
    "MAKE-COLOR"
    "COPY-COLOR"
    "COLOR-R"
    "COLOR-G"
    "COLOR-B"
    "COLOR-RGB"
    "+COLOR-BLACK+"
    "+COLOR-WHITE+"
    "+COLOR-RED+"
    "+COLOR-GREEN+"
    "+COLOR-BLUE+"

    "POINT"
    "POINTP"
    "MAKE-POINT"
    "COPY-POINT"
    "POINT-X"
    "POINT-Y"
    "POINT-POSITION"
    "POINT-DISTANCE"
    "POINT-ROUND"
    "POINT-TRANSLATE"
    "POINT-SCALE"
    "POINT+"
    "POINT-"
    "POINT-MIN"
    "POINT-MAX"
    "POINT="
    "POINT/="
    "POINT<"
    "POINT<="
    "POINT>"
    "POINT>="

    "RECTANGLE"
    "RECTANGLEP"
    "MAKE-RECTANGLE"
    "COPY-RECTANGLE"
    "RECTANGLE-TOP"
    "RECTANGLE-BOTTOM"
    "RECTANGLE-LEFT"
    "RECTANGLE-RIGHT"
    "RECTANGLE-TOP-LEFT"
    "RECTANGLE-TOP-RIGHT"
    "RECTANGLE-BOTTOM-LEFT"
    "RECTANGLE-BOTTOM-RIGHT"
    "RECTANGLE-BOUNDS"
    "RECTANGLE-ROUND"
    "RECTANGLE-TRANSLATE"
    "RECTANGLE-SCALE"
    "RECTANGLE-INTERSECT"
    "RECTANGLE-UNION"
    "RECTANGLE-HEIGHT"
    "RECTANGLE-WIDTH"
    "RECTANGLE-SIZE"
    "RECTANGLE-AREA"
    "RECTANGLE-CENTER"
    
    "MORPH"
    "MORPHP"
    "COPY-MORPH"
    "DEEP-COPY-MORPH"
    "MORPH-BOUNDS"
    "MORPH-COLOR"
    "MORPH-HIGHLIGHT-COLOR"
    "MORPH-OWNER"
    "MORPH-SUBMORPHS"
    "MORPH-FIND-SUBMORPH-AT"
    "MORPH-FIND-SUBMORPH"
    "MORPH-FIND-SUBMORPH-IF"
    "MORPH-ADD-SUBMORPH"
    "MORPH-ADD-SUBMORPH-FRONT"
    "MORPH-ADD-SUBMORPH-BACK"
    "MORPH-ADD-SUBMORPH-BEFORE"
    "MORPH-ADD-SUBMORPH-BEFORE-IF"
    "MORPH-ADD-SUBMORPH-AFTER"
    "MORPH-ADD-SUBMORPH-AFTER-IF"
    "MORPH-ADD-SUBMORPH-AT"
    "MORPH-REMOVE-SUBMORPH"
    "MORPH-REMOVE-SUBMORPH-IF"
    "MORPH-REMOVE-SUBMORPH-AT"
    "MORPH-SUBISTUTE-SUBMORPH"
    "MORPH-DRAW"
    "MORPH-FULL-DRAW"
    "MORPH-HANDLE-EVENT"
    "MORPH-FULL-HANDLE-EVENT"

    "WORLD-MORPH"
    "GRABBABLE-MORPH"
    "RECEPTIVE-MORPH"
    "ELLIPSE-MORPH"
    "ALIGNMENT-MORPH"
    "HORIZONTAL-ALIGNMENT-MORPH"
    "VERTICAL-ALIGNMENT-MORPH"
    "LABEL-MORPH"
    "FORMAT-MORPH"
    "INPUT-MORPH"

    "MAKE-CLX-PORT"))

(defvar *morphicl-files*
  '("setf-star"
    "color"
    "point"
    "rectangle"
    "canvas"
    "event"
    "morph"
    "port"
    "font"
    "morphs/grabbable"
    "morphs/receptive"
    "morphs/world"
    "morphs/ellipse"
    "morphs/alignment"
    "morphs/value"
    "morphs/label"
    "morphs/format"
    "morphs/input"
    "clx-port"
    "test"))

(defun load-morphicl ()
  (mapcar #'load *morphicl-files*))

(defun compile-morphicl ()
  (mapcar #'compile-file *morphicl-files*))

