(in-package "MORPHICL")

(defun test ()
  (let* ((world 
           (make-instance 'world-morph
             :color +color-white+
             :highlight-color +color-white+))
        (port (make-clx-port world)))

    (morph-add-submorph world
      (make-instance 'horizontal-alignment-morph
        :color +color-blue+
        :highlight-color +color-green+
        :bounds (make-rectangle 5/640 5/512 150/640 75/512)))

    (morph-add-submorph world
      (make-instance 'vertical-alignment-morph
        :color +color-green+
        :highlight-color +color-red+
        :bounds (make-rectangle 160/640 160/512 305/640 200/512)))

    (dolist (submorph (morph-submorphs world))
      (dotimes (position 2)
        (morph-add-submorph submorph
          (make-instance 'ellipse-morph
            :color +color-red+
            :highlight-color +color-black+
            :bounds (make-rectangle 0 0 1/2 1/2)))))

    (morph-add-submorph-back world
      (make-instance 'grabbable-morph
        :color +color-green+
        :highlight-color +color-blue+
        :bounds (make-rectangle 205/640 205/512 405/640 305/512)))

    (morph-add-submorph (first (morph-submorphs world))
      (make-instance 'format-morph
        :color +color-black+
        :highlight-color +color-red+
        :bounds (make-rectangle 0 0 1 1/2)
        :control-string "~{~A, ~A~}!"
        :values '((hello world))))

    (morph-add-submorph (first (morph-submorphs world))
      (make-instance 'label-morph
        :color +color-red+
        :highlight-color +color-black+
        :bounds (make-rectangle 0 0 1 1/2)
        :label "Label!"))
  
    (let ((output (make-instance 'format-morph
                    :color +color-black+
                    :highlight-color +color-red+
                    :bounds (make-rectangle 0 1/2 1 3/4)
                    :control-string "~A")))

      (morph-add-submorph (first (morph-submorphs world)) output)

      (morph-add-submorph (first (morph-submorphs world))
        (make-instance 'input-morph
          :color +color-blue+
          :highlight-color +color-white+
          :bounds (make-rectangle 0 3/4 1 1)
          :on-activate #'(lambda (morph input)
                           (declare (ignore morph))
                           (setf (format-morph-values output)
                                 (list (eval (read-from-string input))))))))
                                 
    (unwind-protect
      (port-listen port)
      (port-close port))))

